#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long

struct max_deque{
    deque <pair <int, int> > a;
    int mx;

    void update(int i, int x){
        while(!a.empty() && a.back().first < x){
            a.pop_back();
        }

        a.push_back({x, i});
        mx = max(mx, x);
    }

    void del(int i){
        if(!a.empty() && a.front().second == i){
            a.pop_front();
        }

        mx = a.front().first;
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <int> a(n);

    int f;
    cin >> f;
    if(f == 1){
        for(int i = 0; i < n; ++i){
            cin >> a[i];
        }
    }else{
        int m;
        cin >> m;
        ll x, y, z;
        cin >> x >> y >> z;
        vector <int> c(m);
        for(int i = 0; i < m; ++i){
            cin >> c[i];
        }

        for(int i = 0; i < n; ++i){
            if(i < m){
                a[i] = c[i];
            }else{
                a[i] = ((x * (ll)a[i - 2] + y * (ll)a[i - 1] + z) % 1000000000ll) + 1;
            }
        }
    }


    //multiset <int> s;
    max_deque s;
    s.mx = -1e9;
    for(int i = 0; i < n; ++i){
        s.update(i, a[i] - i);
    }
    int kol = 0;
    int otv = s.mx, pos = 0;

    for(int i = 1; i < n; ++i){
        //s.erase(s.find(a[i - 1] - (i - 1)));
        s.del(i - 1);
        kol++;
        //s.insert(a[i - 1] - (n - 1) - kol);
        s.update(i - 1, a[i - 1] - (n - 1) - kol);
        int x = s.mx + kol;
        if(otv > x){
            otv = x;
            pos = i;
        }
    }

    cout << otv << " " << pos + 1;
}
