#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long

struct max_deque{
    deque <pair <int, int> > a;
    int mx;

    void update(int i, int x){
        while(!a.empty() && a.back().first < x){
            a.pop_back();
        }

        a.push_back({x, i});
        mx = max(mx, x);
    }

    void del(int i){
        if(!a.empty() && a.front().second == i){
            a.pop_front();
        }

        mx = a.front().first;
    }
};

int n, m;

int manaker(vector <int> & a){
    //int n = a.size();

    vector <int> d(n);
    int otv = 0;
    int r = -1, l = -1;
    for(int i = 0; i < n; ++i){
        if(r >= i){
            d[i] = min(d[l + (r - i)], r - i + 1);
            while(i + d[i] < n && i - d[i] >= 0 && a[i + d[i]] == a[i - d[i]]){
                d[i]++;
            }

            if(r < i + d[i] - 1){
                r = i + d[i] - 1;
                l = i - d[i] + 1;
            }
        }else{
            d[i] = 1;
            while(i + d[i] < n && i - d[i] >= 0 && a[i + d[i]] == a[i - d[i]]){
                d[i]++;
            }

            if(r < i + d[i] - 1){
                r = i + d[i] - 1;
                l = i - d[i] + 1;
            }
        }

        otv = max(otv, min(d[i] * 2 - 1, m - (m % 2 == 0)));
    }

    d.assign(n,0);
    l = -1, r = -1;

    for(int i = 0; i < n; ++i){
        if(r >= i){
            d[i] = min(d[l + (r - i)], r - i);
            while(i + (d[i] + 1) < n && i - d[i] >= 0 && a[i + (d[i] + 1)] == a[i - d[i]]){
                d[i]++;
                //cout << i << " " << d[i] << " " << i + d[i] + 1 << " " << i - d[i] << " " << a[i + d[i] + 1] << " " << a[i - d[i]] << '\n';
            }

            if(r < i + d[i]){
                r = i + d[i];
                l = i - d[i] + 1;
            }
        }else{
            d[i] = 0;
            while(i + (d[i] + 1) < n && i - d[i] >= 0 && a[i + (d[i] + 1)] == a[i - d[i]]){
                d[i]++;
            }

            if(r < i + d[i]){
                r = i + d[i];
                l = i - d[i] + 1;
            }
        }

        otv = max(otv, min(d[i] * 2, m - (m % 2 == 1)));
    }

    return otv;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //int n, m;
    cin >> n >> m;
    vector <int> a(n);
    vector <int> b(m);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int j = 0; j < m; ++j){
        cin >> b[j];
    }

    cout << manaker(a);
}
