#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long

struct max_deque{
    deque <pair <int, int> > a;
    int mx;

    void update(int i, int x){
        while(!a.empty() && a.back().first < x){
            a.pop_back();
        }

        a.push_back({x, i});
        mx = max(mx, x);
    }

    void del(int i){
        if(!a.empty() && a.front().second == i){
            a.pop_front();
        }

        mx = a.front().first;
    }
};

int n, m;

int manaker(vector <int> & a){
    int n = a.size();

    vector <int> d(n);
    int otv = 0;
    int r = -1, l = -1;
    for(int i = 0; i < n; ++i){
        if(r >= i){
            d[i] = min(d[l + (r - i)], r - i + 1);
            while(i + d[i] < n && i - d[i] >= 0 && a[i + d[i]] == a[i - d[i]]){
                d[i]++;
            }

            if(r < i + d[i] - 1){
                r = i + d[i] - 1;
                l = i - d[i] + 1;
            }
        }else{
            d[i] = 1;
            while(i + d[i] < n && i - d[i] >= 0 && a[i + d[i]] == a[i - d[i]]){
                d[i]++;
            }

            if(r < i + d[i] - 1){
                r = i + d[i] - 1;
                l = i - d[i] + 1;
            }
        }

        otv = max(otv, min(d[i] * 2 - 1, m - (m % 2 == 0)));
    }

    d.assign(n,0);
    l = -1, r = -1;

    for(int i = 0; i < n; ++i){
        if(r > i){
            d[i] = min(d[l + (r - i) - 1], r - i);
            while(i + (d[i] + 1) < n && i - d[i] >= 0 && a[i + (d[i] + 1)] == a[i - d[i]]){
                d[i]++;
                //cout << i << " " << d[i] << " " << i + d[i] + 1 << " " << i - d[i] << " " << a[i + d[i] + 1] << " " << a[i - d[i]] << '\n';
            }

            if(r < i + d[i]){
                r = i + d[i];
                l = i - d[i] + 1;
            }
        }else{
            d[i] = 0;
            while(i + (d[i] + 1) < n && i - d[i] >= 0 && a[i + (d[i] + 1)] == a[i - d[i]]){
                d[i]++;
            }

            if(r < i + d[i]){
                r = i + d[i];
                l = i - d[i] + 1;
            }
        }

        //cout << d[i] << " ";
        otv = max(otv, min(d[i] * 2, m - (m % 2 == 1)));
    }
    //cout << '\n';

    return otv;
}

int stupid(vector <int> a){
    int otv = 0;
    for(int i = 0; i < n; ++i){
        int kol = 1;
        while(i + kol < n && i - kol >= 0 && a[i + kol] == a[i - kol]){
            kol++;
        }

        otv = max(otv, kol * 2 - 1);

        kol = 0;
        while(i + kol + 1 < n && i - kol >= 0 && a[i + kol + 1] == a[i - kol]){
            kol++;
        }

        otv = max(otv, kol * 2);
    }

    return otv;
}

void stress(){
    m = 100;
    while(true){
        n = rand() % 10;

        vector <int> a(n);
        for(int i = 0; i < n; ++i){
            a[i] = rand() % 6;
        }

        if(manaker(a) != stupid(a)){
            cout << n << " " << manaker(a) << " " << stupid(a) << '\n';
            for(int i = 0; i < n; ++i){
                cout << a[i] << " ";
            }
            cout << '\n';
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //stress();

    cin >> n >> m;
    vector <int> a(n);
    vector <int> b(m);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int j = 0; j < m; ++j){
        cin >> b[j];
    }

    if(n <= 500){
        if(n > m){
            swap(n, m);
            swap(a, b);
        }

        int otv = 0;
        for(int i = -n + 1; i < m; ++i){
            vector <int> c;
            if(i >= 0) {
                c.resize(min(n, m - i));
            }else{
                c.resize(n + i);
            }
            for(int j = max(0ll, i); j < i + n && j < m; ++j){
                c[j - i] = a[j - i] + b[j];
            }

            otv = max(otv, manaker(c));
        }

        cout << otv;
    }else {
        cout << manaker(a);
    }
}
