#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve(){
    int n, q;
    cin >> n >> q;

    vector <int> a(n), b(n), c(q);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int j = 0; j < n; ++j){
        cin >> b[j];
    }
    for(int i = 0; i < q; ++i){
        cin >> c[i];
    }

    sort(a.begin(), a.end());
    sort(b.rbegin(), b.rend());

    vector < pair <int, int> > d;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < n; ++j){
            int D = gcd(a[i], b[j]);
            d.push_back({a[i] / D, b[j] / D});
        }
    }

    sort(d.begin(), d.end(), [](pair <int, int> x, pair <int, int> y){
        return x.first * y.second < y.first * x.second;
    });

    for(int i = 0; i < q; ++i){
        cout << d[c[i] - 1].first << " " << d[c[i] - 1].second << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    /*int tests;
    cin >> tests;
    while(tests--){
        solve();
    }*/
}


/*4 8
3 4 1 2
2 3 4 5
1 16
2 4 5 6 10 15*/