#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, k;
vector < vector <pair <int, int> > > a;
vector < vector < pair <int, int> > > f;

void dfs(int v){
    if(a[v].size() == 0){
        return;
    }

    for(auto to : a[v]){
        dfs(to.first);
    }

    vector < vector < pair <int, int> > > dp(a[v].size(), vector < pair <int, int> > (k + 1));

    dp[0][0] = f[a[v][0].first][0];
    dp[0][1] = {f[a[v][0].first][1].first + 1, f[a[v][0].first][1].second + a[v][0].second};
    for(int i = 0; i + 1 < a[v].size(); ++i){
        for(int j = 0; j <= k; ++j){
            dp[i + 1][j] = max(dp[i + 1][j], {dp[i][j].first + f[a[v][i + 1].first][0].first, dp[i][j].second + f[a[v][i + 1].first][0].second});
            if(j < k){
                dp[i + 1][j + 1] = max(dp[i + 1][j + 1], {dp[i][j].first + f[a[v][i + 1].first][1].first + 1, dp[i][j].second + f[a[v][i + 1].first][1].second + a[v][i + 1].second});
            }
        }
    }

    for(int i = 0; i <= k; ++i){
        f[v][0] = max(f[v][0], dp[a[v].size() - 1][i]);
        if(i < k){
            f[v][1] = max(f[v][1], dp[a[v].size() - 1][i]);
        }
    }
}

void solve(){
    cin >> n >> k;

    a.resize(n);
    f.resize(n, vector < pair <int, int> > (2));
    for(int i = 1; i < n; ++i){
        int x, y;
        cin >> x >> y;
        --x;

        a[x].push_back({i, -y});
    }

    dfs(0);

    cout << f[0][0].first << " " << -f[0][0].second;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    /*int tests;
    cin >> tests;
    while(tests--){
        solve();
    }*/
}
